package org.processmining.dataawarereplayer.precision;

import org.processmining.dataawarereplayer.precision.state.PrecisionState;
import org.processmining.dataawarereplayer.precision.state.StateTransition;
import org.processmining.models.graphbased.directed.petrinet.elements.Place;
import org.processmining.models.semantics.petrinet.Marking;

import com.google.common.collect.SetMultimap;

public interface PrecisionResult {

	double getPrecision();
	double getPrecision(Place p);
	double getPrecision(Marking marking);
	
	long getObservedContinuations(Place p);
	long getPossibleContinuations(Place p);
	long getFrequency(PrecisionState state);
	
	SetMultimap<PrecisionState, StateTransition> getObservedStateTransitions(Place p);
	SetMultimap<PrecisionState, StateTransition> getPossibleStateTransitions(Place p);
	
	SetMultimap<PrecisionState, StateTransition> getPossibleStateTransitions();
	SetMultimap<PrecisionState, StateTransition> getObservedStateTransitions();

	long getPossibleLocalContinuations(Place p);
	long getObservedLocalContinuations(Place p);
	double getLocalPrecision(Place p);

	Object getModel();
	
}
