package org.processmining.dataawarereplayer.precision.state;

import org.processmining.models.graphbased.directed.petrinet.elements.Transition;

public final class StateTransitionActivityImpl implements StateTransition, TransitionAwareStateTransition {

	private final Transition activity;

	public StateTransitionActivityImpl(Transition activity) {
		this.activity = activity;
	}

	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((activity == null) ? 0 : activity.hashCode());
		return result;
	}

	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		StateTransitionActivityImpl other = (StateTransitionActivityImpl) obj;
		if (activity == null) {
			if (other.activity != null)
				return false;
		} else if (!activity.equals(other.activity))
			return false;
		return true;
	}

	public String toString() {
		return activity.getLabel();
	}
	
	@Override
	public Transition getActivity() {
		return activity;
	}
	
}