package org.processmining.plugins.DataConformance.DataAlignment;

import java.util.Iterator;
import java.util.Map.Entry;

import org.processmining.plugins.DataConformance.framework.ExecutionStep;
import org.processmining.plugins.DataConformance.framework.ExecutionTrace;
import org.processmining.plugins.DataConformance.framework.ReplayState;

public class DataAlignmentState extends ReplayState 
{
	private float controlFlowFitness = 1.0f;
	
	public DataAlignmentState(ExecutionTrace logTrace, ExecutionTrace processTrace, float cost) {
		this(logTrace, processTrace, cost, true);
	}
	
	public DataAlignmentState(ExecutionTrace logTrace, ExecutionTrace processTrace, float cost, boolean adjustStringValues) {
		if (adjustStringValues) {
			// This is a workaround for the inprecise String representation in the 'old' data conformance checker.
			Iterator<ExecutionStep> logIter=logTrace.iterator();
			for(ExecutionStep processStep : processTrace)
			{
				ExecutionStep logStep = logIter.next();
				for(Entry<String,Object> entry : processStep.entrySet())
				{
					if (!(entry.getValue() instanceof String))
						continue;
					String processVarValue=(String)entry.getValue();
					Object logVarValue=logStep.get(entry.getKey());
					if (logVarValue !=null && logVarValue instanceof String) 
					{
						String stringLogVarValue=(String)logVarValue;
						if (stringLogVarValue.length() > 4) {
							int stringLength=(int) Math.ceil((Math.min(stringLogVarValue.length(), processVarValue.length())*0.75));
							if (stringLength>0)
								if (stringLogVarValue.substring(0,stringLength).equals(processVarValue.substring(0,stringLength)))
									entry.setValue(logVarValue);
						}
					}
				}
			}
		}
		super.processTracePrefix=processTrace;
		super.logTracePrefix=logTrace;		
		super.f_cost=cost;
	}

	public float getControlFlowFitness() {
		return controlFlowFitness;
	}

	public void setControlFlowFitness(float controlFlowFitness) {
		this.controlFlowFitness=controlFlowFitness;
		
	}	
}
