package org.processmining.plugins.DataConformance.DataAlignment.PetriNet;

import java.util.Collection;
import java.util.Collections;
import java.util.Map;

import org.deckfour.xes.classification.XEventClassifier;
import org.deckfour.xes.classification.XEventNameClassifier;
import org.deckfour.xes.model.XLog;
import org.processmining.datapetrinets.DataPetriNet;
import org.processmining.plugins.DataConformance.ResultReplay;
import org.processmining.plugins.DataConformance.DataAlignment.DataAlignmentHelper;
import org.processmining.plugins.DataConformance.DataAlignment.DataAlignmentState;
import org.processmining.plugins.DataConformance.framework.ReplayState;
import org.processmining.plugins.DataConformance.framework.VariableMatchCosts;

public class ResultReplayPetriNetWithData extends ResultReplay {
	
	private final DataPetriNet net;

	public ResultReplayPetriNetWithData(Collection<? extends DataAlignmentState> alignments,
			VariableMatchCosts variableCost, Map<String, String> variableMapping, DataPetriNet net, XLog log, XEventClassifier classifier) {
		super(alignments, null, variableCost, variableMapping, log, classifier);
		this.net=net;
	}

	/**
	 * Please use other constructor!!
	 */
	@Deprecated
	public ResultReplayPetriNetWithData(Collection<? extends DataAlignmentState> alignments,
			VariableMatchCosts variableCost, DataPetriNet net, XLog log) {
		//TODO remove this constructor
		this(alignments, variableCost, Collections.<String, String>emptyMap(), net, log, new XEventNameClassifier());
	}
	
	
	protected float computeFitness(ReplayState state)
	{
		return DataAlignmentHelper.computeFitness(state, variableCost);
	}

	public DataPetriNet getNet() {
		return net;
	}

}
