package org.processmining.plugins.DataConformance;

import java.util.Collection;
import java.util.Map;
import java.util.Vector;
import java.util.concurrent.LinkedBlockingQueue;
import java.util.concurrent.ThreadPoolExecutor;
import java.util.concurrent.TimeUnit;

import org.deckfour.xes.classification.XEventClasses;
import org.deckfour.xes.model.XLog;
import org.deckfour.xes.model.XTrace;
import org.processmining.contexts.uitopia.UIPluginContext;
import org.processmining.plugins.DataConformance.framework.ActivityMatchCosts;
import org.processmining.plugins.DataConformance.framework.DataReplayer;
import org.processmining.plugins.DataConformance.framework.ReplayState;
import org.processmining.plugins.DataConformance.framework.Replayable;
import org.processmining.plugins.DataConformance.framework.VariableMatchCosts;

public class MultiThreadedConformanceChecking 
{

	
	@SuppressWarnings("unchecked")
	public static Collection<ReplayState> perform(Replayable model, Map activityMapping,
			Map<String, String> variableMapping, XEventClasses eventClasses, XLog log,
			ActivityMatchCosts activityCost, VariableMatchCosts variableCost, 
			Map<String, Float> maxDistance, UIPluginContext context, boolean subOptimalHeur) throws InterruptedException
	{
		Collection<ReplayState> list=new Vector<ReplayState>();
		
		int maxConcurrentThreads=Runtime.getRuntime().availableProcessors();
		
		//ThreadPool pool=new ThreadPool(maxConcurrentThreads);
		
		ThreadPoolExecutor pool = new ThreadPoolExecutor(maxConcurrentThreads, maxConcurrentThreads, 60, TimeUnit.SECONDS,new LinkedBlockingQueue<Runnable>());
		pool.allowCoreThreadTimeOut(true);
		for (XTrace trace : log)
		{
			DataReplayer replayer=new DataReplayer(model, activityMapping, variableMapping, 
					eventClasses,trace, activityCost, variableCost, maxDistance, list, context, subOptimalHeur);
			pool.execute(replayer);
		}
		
		pool.shutdown();
		pool.awaitTermination(10, TimeUnit.HOURS);
				
		return list;
	}

}
