package org.processmining.plugins.DataConformance.framework;

import java.util.HashMap;
import java.util.Map;
import java.util.Set;
import java.util.Stack;

import org.nfunk.jep.function.PostfixMathCommand;
import org.processmining.models.DCNet.DCNet;

public class BelongsTo extends PostfixMathCommand 
{
	private static BelongsTo instance=new BelongsTo();
	private Map<String, Set<Object>> setTable=new HashMap<String,Set<Object>>();
	
	private BelongsTo() 
	{	
		numberOfParameters = 2;
	}
	
	@SuppressWarnings("unchecked")
	public void run(Stack inStack) throws org.nfunk.jep.ParseException
	{
		checkStack(inStack);
		
		Object setName=inStack.pop();
		Object value=inStack.pop();
		if (setName instanceof String)
		{
			Set<Object> aSet=setTable.get(setName);
			boolean ok=false;
			if (aSet==null) {
				throw new org.nfunk.jep.ParseException("Invalid parameter type: the set does not exist");	
			}
			if (value instanceof Number) {
				for(Object x : aSet)
					if (x instanceof Number && ((Number)x).doubleValue()==((Number)value).doubleValue()) {
						ok=true;
						break;
					}
			} else {
				ok=aSet.contains(value);
			}
			if (ok)
				inStack.push(1);
			else
				inStack.push(0);
		}
		else
			throw new org.nfunk.jep.ParseException("Invalid parameter type: the set name needs to be a String");
	}
	 
	public static BelongsTo getInstance()
	{
		return instance;
	}
	
	@SuppressWarnings("unchecked")
	public void resetForDCNet(DCNet model) {
		setTable = (Map)model.getSetTable();
		
	}

	
}
