package org.processmining.plugins.DataConformance.framework;


public class VariableMatchCost 
{
	
	/**
	 * Activity that this cost refers to, might be NULL in which case it is not bound to a special attribute (i.e., means *)
	 */
	private String activity=null;
	
	/**
	 * Attribute that this cost refers to, might be NULL in which case it is not bound to a special attribute (i.e., means *)
	 */
	private String attribute=null;
	
	private float costNotWriting;
	private float costFaultyValue;
	private boolean isFinal;
	
	/**
	 *  Default constructor initializing with zero cost
	 */
	public VariableMatchCost() {
		this(0, 0);
	}
	
	public VariableMatchCost(int costFaultyValue, int defaultCostNotWriting) {
		this.costFaultyValue = costFaultyValue;
		this.costNotWriting = defaultCostNotWriting;
	}

	public String toString()
	{
		return activity+" "+attribute+" "+costNotWriting+" "+costFaultyValue;
	}	
	
	public String getActivity() {
		return activity;
	}
	
	/**
	 * @param activity that this cost refers to, might be NULL in which case it is not bound to a special attribute (i.e., means *)
	 */
	public void setActivity(String activity) 
	{
		this.activity = activity;
	
	}
	public String getVariable() {
		return attribute;
	}
	
	/**
	 * @param variable that this cost refers to, might be NULL in which case it is not bound to a special attribute (i.e., means *)
	 */
	public void setVariable(String variable) {
		attribute = variable;
	}
	
	public float getCostNotWriting() {
		return costNotWriting;
	}
	
	public void setCostNotWriting(float costNotWriting) {
		this.costNotWriting = costNotWriting;
	}
	
	public float getCostFaultyValue() {
		return costFaultyValue;
	}
	
	public void setCostFaultyValue(float costFaultyValue) {
		this.costFaultyValue = costFaultyValue;
	}

	public boolean isFinal() {
		return isFinal;
	}

	public void setFinal(boolean isFinal) {
		this.isFinal = isFinal;
	}
	
}
