/*
 * Mainly copied from PNetReplayer package
 */
package org.processmining.plugins.balancedconformance.controlflow.override.queues.duplicates;

import java.util.Random;

import nl.tue.astar.Record;

public class RandomFirstDuplicatePriorityQueue extends DuplicateStatesFastLookupPriorityQueue {

	private final double probability;

	public RandomFirstDuplicatePriorityQueue(int initialCapacity, double probability) {
		super(initialCapacity);
		this.probability = probability;
	}

	private Random r = new Random();

	@Override
	public boolean isBetter(Record r1, Record r2) {
		// retrieve stored cost
		double c1 = r1.getTotalCost();
		double c2 = r2.getTotalCost();

		if (c1 == c2) {

			return r.nextDouble() < probability;
		}
		return c1 < c2;
	}
}