/*
 * Copyright (c) 2013 F. Mannhardt (f.mannhardt@tue.nl)
 */
package org.processmining.plugins.balancedconformance.export;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.IOException;

import org.deckfour.xes.model.XLog;
import org.processmining.contexts.uitopia.annotations.UIExportPlugin;
import org.processmining.framework.plugin.PluginContext;
import org.processmining.framework.plugin.annotations.Plugin;
import org.processmining.framework.plugin.annotations.PluginLevel;
import org.processmining.framework.plugin.annotations.PluginVariant;
import org.processmining.log.utils.XUtils;
import org.processmining.plugins.balancedconformance.result.AlignmentCollection;

/**
 * Exports a {@link AlignmentCollection} as XES, including meta-data such as
 * fitness, and, possibly, the attributes of the event log.
 * 
 * @author F. Mannhardt
 */
@Plugin(name = "Export Alignments as XES (.xes)", level = PluginLevel.Regular, returnLabels = {}, returnTypes = {}, parameterLabels = {
		"AlignmentCollection", "File" }, userAccessible = true)
@UIExportPlugin(description = "Export Alignments as XES (.xes)", extension = "xes")
public class ExportAsXESBalancedReplayResult {

	@PluginVariant(variantLabel = "Export Alignments as XES (.xes)", requiredParameterLabels = { 0, 1 })
	public void exportAsXES(final PluginContext context, AlignmentCollection res, File file) throws FileNotFoundException, IOException {
		
		XLog extendLogWithAlignments = ExtendLogWithAlignments.doExtendLogWithAlignments(context, res);
		XUtils.saveLog(extendLogWithAlignments, file);
		
	}

}
